/* Automatically generated by Kelbt from "klparse.kl".
 *
 * Parts of this file are copied from Kelbt source covered by the GNU
 * GPL. As a special exception, you may use the parts of this file copied
 * from Kelbt source without restriction. The remainder is derived from
 * "klparse.kl" and inherits the copyright status of that file.
 */

/*
 *  Copyright 2006 Adrian Thurston <thurston@cs.queensu.ca>
 */

/*  This file is part of Kelbt.
 *
 *  Kelbt is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 * 
 *  Kelbt is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *  You should have received a copy of the GNU General Public License
 *  along with Kelbt; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 */

#include "klparse.h"
#include "kelbt.h"
#include <iostream>

using std::cout;
using std::cerr;
using std::endl;

#line 40 "klparse.cpp"
#define KW_Parser 128
#define KW_Include 129
#define TK_Word 130
#define TK_String 131
#define KW_Commit 132
#define KW_Interface 133
#define KW_Try 134
#define KW_Undo 135
#define KW_Final 136
#define KW_Translate 137
#define KW_Token 138
#define KW_NonTerm 139
#define KW_Uses 140
#define KW_Type 141
#define KW_Pri 142
#define TK_Number 143
#define TK_Inline 144
#define TK_Reference 145
#define TK_Literal 146
#define _eof 147

	LangEl *freshEl;
	int freshPos;
	LangEl *pool;
	int numRetry;
	int numNodes;
	LangEl *stackTop;
	LangEl *lastFinal;
	int errCount;
	int curs;

	int init();
	int parseLangEl( int type, const Token &token );
	int finish();

#line 1 "klparse.kl"
#line 78 "klparse.cpp"
/*
	KW_Parser 128
	KW_Include 129
	TK_Word 130
	TK_String 131
	KW_Commit 132
	KW_Interface 133
	KW_Try 134
	KW_Undo 135
	KW_Final 136
	KW_Translate 137
	KW_Token 138
	KW_NonTerm 139
	KW_Uses 140
	KW_Type 141
	KW_Pri 142
	TK_Number 143
	TK_Inline 144
	TK_Reference 145
	TK_Literal 146
	statement_list 148
	start 149
	statement 150
	production_stmt 151
	token_stmt 152
	translate_stmt 153
	nonterm_stmt 154
	type_stmt 155
	interface_stmt 156
	prod_el_list 157
	opt_commit 158
	opt_reduction 159
	opt_undo 160
	opt_final 161
	token_list 162
	token_list_word 163
	opt_translate 164
	inline_list 165
	inline_block_item 166
	prod_el 167
	opt_prior 168
	_eof 147
	_start 169
*/

struct Lel_inline_block_item
{
#line 159 "klparse.kl"

	InlineItem *inlineItem;
	InputLoc loc;


#line 132 "klparse.cpp"
};

struct Lel_inline_list
{
#line 137 "klparse.kl"

	InlineList *inlineList;
	InputLoc loc;


#line 143 "klparse.cpp"
};

struct Lel_opt_commit
{
#line 219 "klparse.kl"

	bool commit;


#line 153 "klparse.cpp"
};

struct Lel_opt_inline_block
{
#line 239 "klparse.kl"

	InlineBlock *inlineBlock;


#line 163 "klparse.cpp"
};

struct Lel_opt_prior
{
#line 227 "klparse.kl"

	int priorVal;


#line 173 "klparse.cpp"
};

struct Lel_prod_el
{
#line 194 "klparse.kl"

	Factor *factor;


#line 183 "klparse.cpp"
};

struct Lel_prod_el_list
{
#line 179 "klparse.kl"

	ProdElList *prodElList;


#line 193 "klparse.cpp"
};

union UserData
{
	Lel_inline_block_item inline_block_item;
	Lel_inline_list inline_list;
	Lel_opt_commit opt_commit;
	Lel_opt_inline_block opt_inline_block;
	Lel_opt_prior opt_prior;
	Lel_prod_el prod_el;
	Lel_prod_el_list prod_el_list;
	Token token;
};

#define act_shift 1
#define act_reduce 2
#define act_sr 3
#define act_sb 0x1
#define act_rb 0x2
#define lower 0x0000ffff
#define upper 0xffff0000
struct LangEl
{
	char *file;
	int line;
	int type;
	int reduction;
	int state;
	UserData user;
	unsigned int retry;
	LangEl *next, *child;
};

extern unsigned char keys[];
extern unsigned char targs[];
extern char indicies[];
extern unsigned int actInds[];
extern unsigned int actions[];
extern int commitLen[];
extern unsigned short offsets[];
extern unsigned int fssProdIdIndex[];
extern char fssProdLengths[];
extern unsigned char prodLhsIds[];
extern char *prodNames[];
extern char *lelNames[];
extern char prodCommit[];
extern unsigned int startState;

int Parser::init()
{
	curs = startState;
	pool = 0;
	freshEl = new LangEl[8128];
	#ifdef LOG_ACTIONS
	cerr << "allocating 8128 LangEls" << endl;
	#endif
	stackTop = freshEl;
	stackTop->type = 0;
	stackTop->state = -1;
	freshPos = 1;
	lastFinal = stackTop;
	numRetry = 0;
	numNodes = 0;
	errCount = 0;
	return 0;
}

#define reject() induceReject = true

int Parser::parseLangEl( int type, const Token &token )
{
	int pos, targState;
	unsigned int *action;
	int rhsLen;
	LangEl *rhs[32];
	bool induceReject;

	if ( curs < 0 )
		return 0;

	LangEl *input;
	if ( pool == 0 ) {
		if ( freshPos == 8128 ) {
			freshEl = new LangEl[8128];
			#ifdef LOG_ACTIONS
			cerr << "allocating 8128 LangEls" << endl;
			#endif
			freshPos = 0;
		}
		input = freshEl + freshPos++;
	}
	else {
		input = pool;
		pool = pool->next;
	}
	numNodes += 1;
	input->type = type;
	input->user.token = token;
	input->next = 0;
	input->retry = 0;
	input->child = 0;

again:
	if ( input == 0 )
		return 0;

	LangEl *lel = input;
	if ( lel->type < keys[curs<<1] || lel->type > keys[(curs<<1)+1] )
		goto parseError;

	pos = indicies[offsets[curs] + (lel->type - keys[curs<<1])];
	if ( pos < 0 )
		goto parseError;

	induceReject = false;
	targState = targs[pos];
	action = actions + actInds[pos];
	if ( lel->retry & lower )
		action += (lel->retry & lower);

	if ( *action & act_sb ) {
		#ifdef LOG_ACTIONS
		cerr << "shifted: " << lelNames[lel->type];
		#endif
		input = input->next;
		lel->state = curs;
		lel->next = stackTop;
		stackTop = lel;

		if ( action[1] == 0 )
			lel->retry &= upper;
		else {
			lel->retry += 1;
			numRetry += 1;
			#ifdef LOG_ACTIONS
			cerr << " retry: " << stackTop;
			#endif
		}
		#ifdef LOG_ACTIONS
		cerr << endl;
		#endif
	}

	if ( commitLen[pos] != 0 ) {
		#ifdef LOG_ACTIONS
		cerr << "running commit of length: " << commitLen[pos] << endl;
		#endif

		LangEl *commitHead = stackTop;
		int absCommitLen = commitLen[pos];
		if ( absCommitLen < 0 ) {
			commitHead = commitHead->next;
			absCommitLen = -1 * absCommitLen;
		}
		{
			LangEl *lel = commitHead, *cmStack[numNodes];
			int n = absCommitLen, depth = 0, sp = 0;

commit_head:
			if ( lel->retry > 0 ) {
				if ( lel->retry & lower )
					numRetry -= 1;
				if ( lel->retry & upper )
					numRetry -= 1;
				lel->retry = 0;
			}

			/* If depth is > 0 then move over lel freely, otherwise, make
			 * sure that we have not already done n steps down the line. */
			if ( lel->next != 0 && ( depth > 0 || n > 1 ) ) {
				cmStack[sp++] = lel;
				lel = lel->next;

				/* If we are at the top level count the steps down the line. */
				if ( depth == 0 )
					n -= 1;
				goto commit_head;
			}

commit_reverse:
			if ( lel->child != 0 ) {
				cmStack[sp++] = lel;
				lel = lel->child;

				/* When we move down we need to increment the depth. */
				depth += 1;
				goto commit_head;
			}

commit_upwards:
			if ( sp > 0 ) {
				/* Figure out which place to return to. */
				if ( cmStack[sp-1]->next == lel ) {
					lel = cmStack[--sp];
					goto commit_reverse;
				}
				else {
					/* Going back up, adjust the depth. */
					lel = cmStack[--sp];
					depth -= 1;
					goto commit_upwards;
				}
			}
		}
		if ( numRetry == 0 ) {
			#ifdef LOG_ACTIONS
			cerr << "number of retries is zero, "
				"executing final actions" << endl;
			#endif
			{
				LangEl *lel = commitHead, *cmStack[numNodes];
				int sp = 0;
				bool doExec = false;

final_head:
				if ( lel == lastFinal ) {
					doExec = true;
					goto hit_final;
				}

				if ( lel->next != 0 ) {
					cmStack[sp++] = lel;
					lel = lel->next;
					goto final_head;
				}

final_reverse:

				if ( lel->child != 0 ) {
					cmStack[sp++] = lel;
					lel = lel->child;
					goto final_head;
				}

final_upwards:

				if ( doExec ) {
{
	if ( lel->type < 148 ) {
	}
	else {
		LangEl *redLel = lel;
		if ( redLel->child != 0 ) {
			int r = fssProdLengths[redLel->reduction] - 1;
			LangEl *rhsEl = redLel->child;
			while ( rhsEl != 0 ) {
				rhs[r--] = rhsEl;
				rhsEl = rhsEl->next;
			}
		}
switch ( lel->reduction ) {
}
	}
}

					if ( lel->child != 0 ) {
						numNodes -= 1;
						LangEl *first = lel->child;
						LangEl *child = lel->child;
						lel->child = 0;
						while ( child->next != 0 ) {
							child = child->next;
							numNodes -= 1;
						}
						child->next = pool;
						pool = first;
					}
				}

hit_final:
				if ( sp > 0 ) {
					/* Figure out which place to return to. */
					if ( cmStack[sp-1]->next == lel ) {
						lel = cmStack[--sp];
						goto final_reverse;
					}
					else {
						lel = cmStack[--sp];
						goto final_upwards;
					}
				}

				lastFinal = lel;
			}
		}
	}

	if ( *action & act_rb ) {
		int fssRed = *action >> 2;
		int reduction = fssProdIdIndex[fssRed];
		LangEl *redLel;
		if ( pool == 0 ) {
			if ( freshPos == 8128 ) {
				freshEl = new LangEl[8128];
				#ifdef LOG_ACTIONS
				cerr << "allocating 8128 LangEls" << endl;
				#endif
				freshPos = 0;
			}
			redLel = freshEl + freshPos++;
		}
		else {
			redLel = pool;
			pool = pool->next;
		}
		numNodes += 1;
		redLel->type = prodLhsIds[reduction];
		redLel->reduction = reduction;
		redLel->child = 0;
		redLel->next = 0;
		redLel->retry = (lel->retry << 16);
		lel->retry &= upper;

		rhsLen = fssProdLengths[fssRed];
		if ( rhsLen > 0 ) {
			for ( int r = rhsLen-1; r > 0; r-- ) {
				rhs[r] = stackTop;
				stackTop = stackTop->next;
			}
			rhs[0] = stackTop;
			stackTop = stackTop->next;
			rhs[0]->next = 0;
		}
switch ( reduction ) {
case 9: {
#line 50 "klparse.kl"

		/* Get the language element. */
		KlangEl *prodName = getKlangEl( &pd, (&rhs[0]->user.token)->data, KlangEl::NonTerm );

		/* Check that the element wasn't previously defined as something else. */
		if ( prodName->type != KlangEl::Unknown 
				&& prodName->type != KlangEl::NonTerm )
		{
			error((&rhs[0]->user.token)->loc) << "'" << (&rhs[0]->user.token)->data << "' already defined as something else" << endl;
		}
		else {
			prodName->type = KlangEl::NonTerm;
			Definition *newDef = new Definition( (&rhs[0]->user.token)->loc, prodName, (&rhs[2]->user.prod_el_list)->prodElList,
					(&rhs[3]->user.opt_commit)->commit, (&rhs[4]->user.opt_inline_block)->inlineBlock, (&rhs[5]->user.opt_inline_block)->inlineBlock, (&rhs[6]->user.opt_inline_block)->inlineBlock, 
					pd.prodList.length(), Definition::Production );
			prodName->defList.append( newDef );
			pd.prodList.append( newDef );

			/* Start machine will trigger code generation. */
			if ( strcmp((&rhs[0]->user.token)->data, startDefName) == 0 )
				sawStart = true;

			newDef->rhsLelVect = langElVect;
			newDef->rhsFactorVect = factorVect;
			langElVect.empty();
			factorVect.empty();
		}
	

#line 549 "klparse.cpp"
} break;
case 13: {
#line 85 "klparse.kl"

		/* Token name must be unique. */
		KlangEl *tokName = getKlangEl( &pd, (&rhs[0]->user.token)->data, KlangEl::Term );
		if ( tokName->type != KlangEl::Unknown && tokName->type != KlangEl::Term )
			error((&rhs[0]->user.token)->loc) << "'" << (&rhs[0]->user.token) << "' already defined as something else" << endl;
		tokName->type = KlangEl::Term;
	

#line 561 "klparse.cpp"
} break;
case 14: {
#line 95 "klparse.kl"

		pd.translateBlock = (&rhs[1]->user.opt_inline_block)->inlineBlock;
		pd.undoTransBlock = (&rhs[2]->user.opt_inline_block)->inlineBlock;
		pd.tokenFinalBlock = (&rhs[3]->user.opt_inline_block)->inlineBlock;
	

#line 571 "klparse.cpp"
} break;
case 15: {
#line 103 "klparse.kl"

		KlangEl *nonTerm = getKlangEl( &pd, (&rhs[1]->user.token)->data, KlangEl::NonTerm );
		nonTerm->typeDef = new TypeDef( (&rhs[1]->user.token)->data, new InlineBlock( (&rhs[2]->user.inline_list)->loc, 
				(&rhs[2]->user.inline_list)->inlineList ) );
		pd.typeDefMap.insert( (&rhs[1]->user.token)->data, nonTerm->typeDef );
	

#line 582 "klparse.cpp"
} break;
case 16: {
#line 112 "klparse.kl"

		KlangEl *nonTerm = getKlangEl( &pd, (&rhs[1]->user.token)->data, KlangEl::NonTerm );
		TypeDefMapEl *tdmel = pd.typeDefMap.find( (&rhs[3]->user.token)->data );
		if ( tdmel != 0 )
			nonTerm->typeDef = tdmel->value;
		else {
			error((&rhs[0]->user.token)->loc) << "bad uses statement" << endl;
		}
	

#line 596 "klparse.cpp"
} break;
case 17: {
#line 124 "klparse.kl"

		TypeDef *newTypeDef = new TypeDef( (&rhs[1]->user.token)->data, 
				new InlineBlock( InputLoc((&rhs[2]->user.inline_list)->loc), (&rhs[2]->user.inline_list)->inlineList ) );
		pd.typeDefMap.insert( (&rhs[1]->user.token)->data, newTypeDef );
	

#line 606 "klparse.cpp"
} break;
case 18: {
#line 132 "klparse.kl"

		sawInterface = true;
	

#line 614 "klparse.cpp"
} break;
case 19: {
#line 144 "klparse.kl"

		(&rhs[0]->user.inline_list)->inlineList->append( (&rhs[1]->user.inline_block_item)->inlineItem );
		(&redLel->user.inline_list)->inlineList = (&rhs[0]->user.inline_list)->inlineList;
		(&redLel->user.inline_list)->loc = (&rhs[0]->user.inline_list)->loc;
	

#line 624 "klparse.cpp"
} break;
case 20: {
#line 152 "klparse.kl"

		(&redLel->user.inline_list)->inlineList = new InlineList;
		(&redLel->user.inline_list)->inlineList->append( (&rhs[0]->user.inline_block_item)->inlineItem );
		(&redLel->user.inline_list)->loc = (&rhs[0]->user.inline_block_item)->loc;
	

#line 634 "klparse.cpp"
} break;
case 21: {
#line 166 "klparse.kl"

		(&redLel->user.inline_block_item)->inlineItem = new InlineItem( (&rhs[0]->user.token)->loc, (&rhs[0]->user.token)->data, InlineItem::Text );
		(&redLel->user.inline_block_item)->loc = (&rhs[0]->user.token)->loc;
	

#line 643 "klparse.cpp"
} break;
case 22: {
#line 173 "klparse.kl"

		(&redLel->user.inline_block_item)->inlineItem = new InlineItem( (&rhs[0]->user.token)->loc, (&rhs[0]->user.token)->data, InlineItem::Reference );
		(&redLel->user.inline_block_item)->loc = (&rhs[0]->user.token)->loc;
	

#line 652 "klparse.cpp"
} break;
case 23: {
#line 185 "klparse.kl"

		(&rhs[0]->user.prod_el_list)->prodElList->append( (&rhs[1]->user.prod_el)->factor );
		(&redLel->user.prod_el_list)->prodElList = (&rhs[0]->user.prod_el_list)->prodElList;
	

#line 661 "klparse.cpp"
} break;
case 24: {
#line 191 "klparse.kl"
 (&redLel->user.prod_el_list)->prodElList = new ProdElList; 

#line 667 "klparse.cpp"
} break;
case 25: {
#line 200 "klparse.kl"

		KlangEl *langEl = getKlangEl( &pd, (&rhs[2]->user.token)->data, KlangEl::Unknown );
		(&redLel->user.prod_el)->factor = new Factor( (&rhs[2]->user.token)->loc, (&rhs[1]->user.opt_commit)->commit, langEl, (&rhs[0]->user.opt_prior)->priorVal );
		langElVect.append( langEl );
		factorVect.append( (&redLel->user.prod_el)->factor );
	

#line 678 "klparse.cpp"
} break;
case 26: {
#line 209 "klparse.kl"

		/* Create a new factor node going to a concat literal. */
		Literal *literal = new Literal( (&rhs[2]->user.token)->loc, (&rhs[2]->user.token)->data[0] );
		(&redLel->user.prod_el)->factor = new Factor( (&rhs[2]->user.token)->loc, (&rhs[1]->user.opt_commit)->commit, literal, (&rhs[0]->user.opt_prior)->priorVal );
		langElVect.append( 0 );
		factorVect.append( (&redLel->user.prod_el)->factor );
	

#line 690 "klparse.cpp"
} break;
case 27: {
#line 223 "klparse.kl"
 (&redLel->user.opt_commit)->commit = false; 

#line 696 "klparse.cpp"
} break;
case 28: {
#line 224 "klparse.kl"
 (&redLel->user.opt_commit)->commit = true; 

#line 702 "klparse.cpp"
} break;
case 29: {
#line 232 "klparse.kl"
 
		(&redLel->user.opt_prior)->priorVal = atoi( (&rhs[2]->user.token)->data );
	

#line 710 "klparse.cpp"
} break;
case 30: {
#line 236 "klparse.kl"
 (&redLel->user.opt_prior)->priorVal = 0; 

#line 716 "klparse.cpp"
} break;
case 31: {
#line 249 "klparse.kl"
 (&redLel->user.opt_inline_block)->inlineBlock = 0; 

#line 722 "klparse.cpp"
} break;
case 32: {
#line 252 "klparse.kl"
 
		(&redLel->user.opt_inline_block)->inlineBlock = new InlineBlock( (&rhs[1]->user.inline_list)->loc, (&rhs[1]->user.inline_list)->inlineList );
	

#line 730 "klparse.cpp"
} break;
case 33: {
#line 256 "klparse.kl"
 (&redLel->user.opt_inline_block)->inlineBlock = 0; 

#line 736 "klparse.cpp"
} break;
case 34: {
#line 259 "klparse.kl"
 
		(&redLel->user.opt_inline_block)->inlineBlock = new InlineBlock( (&rhs[1]->user.inline_list)->loc, (&rhs[1]->user.inline_list)->inlineList );
	

#line 744 "klparse.cpp"
} break;
case 35: {
#line 263 "klparse.kl"
 (&redLel->user.opt_inline_block)->inlineBlock = 0; 

#line 750 "klparse.cpp"
} break;
case 36: {
#line 266 "klparse.kl"
 
		(&redLel->user.opt_inline_block)->inlineBlock = new InlineBlock( (&rhs[1]->user.inline_list)->loc, (&rhs[1]->user.inline_list)->inlineList );
	

#line 758 "klparse.cpp"
} break;
case 37: {
#line 270 "klparse.kl"
 (&redLel->user.opt_inline_block)->inlineBlock = 0; 

#line 764 "klparse.cpp"
} break;
case 38: {
#line 273 "klparse.kl"
 
		(&redLel->user.opt_inline_block)->inlineBlock = new InlineBlock( (&rhs[1]->user.inline_list)->loc, (&rhs[1]->user.inline_list)->inlineList );
	

#line 772 "klparse.cpp"
} break;
}
		#ifdef LOG_ACTIONS
		cerr << "reduced: "
				<< prodNames[reduction]
				<< " rhsLen: " << rhsLen;
		#endif
		if ( action[1] == 0 )
			redLel->retry = 0;
		else {
			redLel->retry += 0x10000;
			numRetry += 1;
			#ifdef LOG_ACTIONS
			cerr << " retry: " << redLel;
			#endif
		}

		#ifdef LOG_ACTIONS
		cerr << endl;
		#endif

		if ( rhsLen == 0 ) {
			redLel->file = lel->file;
			redLel->line = lel->line;
			targState = curs;
		}
		else {
			redLel->child = rhs[rhsLen-1];
			redLel->file = rhs[0]->file;
			redLel->line = rhs[0]->line;
			targState = rhs[0]->state;
		}

		if ( induceReject ) {
			#ifdef LOG_ACTIONS
			cerr << "error induced during reduction of " <<
					lelNames[redLel->type] << endl;
			#endif
			redLel->state = curs;
			redLel->next = stackTop;
			stackTop = redLel;
			curs = targState;
			goto parseError;
		}
		else {
			redLel->next = input;
			input = redLel;
		}
	}


	curs = targState;
	goto again;

parseError:
	#ifdef LOG_BACKTRACK
	cerr << "hit error" << endl;
	#endif
	if ( numRetry > 0 ) {
		while ( true ) {
			LangEl *redLel = stackTop;
			if ( stackTop->type < 148 ) {
				#ifdef LOG_BACKTRACK
				cerr << "backing up over terminal: " <<
						lelNames[stackTop->type] << endl;
				#endif
				stackTop = stackTop->next;
				redLel->next = input;
				input = redLel;
			}
			else {
				#ifdef LOG_BACKTRACK
				cerr << "backing up over non-terminal: " <<
						lelNames[stackTop->type] << endl;
				#endif
				stackTop = stackTop->next;
				LangEl *first = redLel->child;
				if ( first == 0 )
					rhsLen = 0;
				else {
					rhsLen = 1;
					while ( first->next != 0 ) {
						first = first->next;
						rhsLen += 1;
					}
					first->next = stackTop;
					stackTop = redLel->child;

					LangEl *rhsEl = stackTop;
					int p = rhsLen;
					while ( p > 0 ) {
						rhs[--p] = rhsEl;
						rhsEl = rhsEl->next;
					}
				}
switch ( redLel->reduction ) {
}
				redLel->next = pool;
				pool = redLel;
				numNodes -= 1;
			}

			if ( redLel->retry > 0 ) {
				#ifdef LOG_BACKTRACK
				cerr << "found retry targ: " << redLel << endl;
				#endif
				numRetry -= 1;
				#ifdef LOG_BACKTRACK
				cerr << "found retry: " << redLel << endl;
				#endif
				if ( redLel->retry & lower )
					curs = input->state;
				else {
					input->retry = redLel->retry >> 16;
					if ( stackTop->state < 0 )
						curs = startState;
					else {
						curs = targs[(int)indicies[offsets[stackTop->state] + 
							(stackTop->type - keys[stackTop->state<<1])]];
					}
				}
				goto again;
			}
		}
	}
	curs = -1;
	errCount += 1;
	return -1;
}

int Parser::finish()
{
	#ifdef LOG_ACTIONS
	cerr << "numNodes: " << numNodes << endl;
	#endif
	return errCount;
}
unsigned int startState = 0;

char indicies[] = {
	41, -1, -1, 41, -1, -1, -1, -1, 
	41, 41, -1, 41, -1, -1, -1, -1, 
	-1, 41, 1, 0, 78, 2, -1, -1, 
	6, -1, -1, -1, -1, 3, 4, -1, 
	5, -1, -1, -1, -1, -1, 39, -1, 
	-1, 40, 72, 73, 74, 75, 76, 77, 
	7, 70, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	46, -1, -1, -1, -1, 70, 70, 10, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	8, 45, 9, 11, 12, 51, 57, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 57, -1, 57, 
	-1, 57, 57, 57, -1, -1, -1, -1, 
	-1, 57, -1, -1, -1, 57, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	13, 15, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	43, 66, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 17, 66, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 16, 54, 
	55, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 14, 53, 19, -1, 
	-1, -1, 54, 55, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 18, 
	53, 54, 55, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 20, 53, 
	60, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 63, 
	-1, 23, -1, 60, 60, 60, -1, -1, 
	-1, -1, -1, 25, -1, -1, -1, 63, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 21, -1, -1, -1, -1, 
	-1, -1, -1, -1, 56, 24, 71, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 71, 71, -1, -1, -1, -1, 
	-1, -1, -1, 54, 55, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 52, 46, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 44, 68, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 28, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 27, 54, 55, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	26, 53, 48, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 54, 
	55, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 52, 29, 50, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 54, 55, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 52, 64, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 32, 64, 
	64, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 31, 
	61, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 61, 
	-1, -1, -1, 61, 61, 61, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 61, 
	60, -1, 22, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	60, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 33, 30, 67, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 67, -1, -1, -1, -1, 
	-1, -1, -1, 54, 55, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 52, 47, 54, 55, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	34, 53, 49, 35, 66, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	17, 66, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 37, 54, 55, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 36, 
	53, 58, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 59, 69, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 54, 
	55, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 52, 62, 65, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 65, 65, -1, -1, -1, 
	-1, -1, -1, -1, 54, 55, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 52, 68, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	28, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 38, 42, 
};

unsigned char keys[] = {
	130, 149, 147, 147, 130, 156, 58, 58, 
	59, 164, 130, 130, 130, 130, 59, 59, 
	59, 157, 44, 59, 59, 160, 144, 166, 
	140, 166, 144, 166, 59, 168, 59, 166, 
	130, 163, 59, 161, 144, 166, 59, 166, 
	130, 130, 59, 166, 59, 159, 59, 146, 
	130, 158, 40, 40, 59, 166, 59, 59, 
	144, 166, 59, 59, 143, 143, 59, 160, 
	144, 166, 130, 146, 59, 166, 41, 41, 
	59, 166, 59, 161, 59, 59, 0, 0
};

unsigned short offsets[] = {
	0, 20, 21, 48, 49, 155, 156, 157, 
	158, 257, 273, 375, 398, 425, 448, 558, 
	666, 700, 803, 826, 934, 935, 1043, 1144, 
	1232, 1261, 1262, 1370, 1371, 1394, 1395, 1396, 
	1498, 1521, 1538, 1646, 1647, 1755, 1858, 1859
};

unsigned char targs[] = {
	1, 2, 3, 4, 5, 6, 7, 8, 
	9, 10, 11, 12, 13, 14, 15, 16, 
	17, 18, 19, 20, 21, 22, 23, 23, 
	24, 25, 26, 27, 28, 29, 30, 31, 
	32, 33, 34, 35, 36, 37, 38, 39, 
	39, 39, 39, 39, 39, 39, 39, 39, 
	39, 39, 39, 39, 39, 39, 39, 39, 
	39, 39, 39, 39, 39, 39, 39, 39, 
	39, 39, 39, 39, 39, 39, 39, 39, 
	39, 39, 39, 39, 39, 39, 39
};

unsigned int actInds[] = {
	0, 2, 4, 6, 8, 10, 12, 14, 
	16, 18, 20, 22, 24, 26, 28, 30, 
	32, 34, 36, 38, 40, 42, 44, 46, 
	49, 51, 53, 55, 57, 59, 61, 63, 
	65, 67, 69, 71, 73, 75, 77, 79, 
	81, 83, 85, 87, 89, 91, 93, 95, 
	97, 99, 101, 103, 105, 107, 109, 111, 
	113, 115, 117, 119, 121, 123, 125, 127, 
	129, 131, 133, 135, 137, 139, 141, 143, 
	145, 147, 149, 151, 153, 155, 157
};

unsigned int actions[] = {
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 122, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 2, 
	0, 7, 0, 10, 0, 39, 0, 43, 
	0, 47, 0, 51, 0, 55, 0, 59, 
	0, 63, 0, 67, 0, 71, 0, 75, 
	0, 79, 0, 83, 0, 87, 0, 91, 
	0, 95, 0, 98, 0, 103, 0, 107, 
	0, 110, 0, 114, 0, 119, 0, 122, 
	0, 126, 0, 130, 0, 134, 0, 138, 
	0, 142, 0, 146, 0, 150, 0, 154, 
	0, 15, 0, 19, 0, 23, 0, 27, 
	0, 31, 0, 35, 0, 1, 0
};

int commitLen[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	1, 1, 1, 1, 1, 1, 2
};

unsigned int fssProdIdIndex[] = {
	0, 1, 2, 3, 4, 5, 6, 7, 
	8, 9, 10, 11, 12, 13, 14, 15, 
	16, 17, 18, 19, 20, 21, 22, 23, 
	24, 25, 26, 27, 28, 29, 30, 31, 
	32, 33, 34, 35, 36, 37, 38, 39
};

char fssProdLengths[] = {
	1, 2, 0, 1, 1, 1, 1, 1, 
	1, 8, 3, 3, 1, 1, 5, 4, 
	5, 4, 2, 2, 1, 1, 1, 2, 
	0, 3, 3, 0, 1, 4, 0, 0, 
	2, 0, 2, 0, 2, 0, 2, 1
};

unsigned char prodLhsIds[] = {
	149, 148, 148, 150, 150, 150, 150, 150, 
	150, 151, 152, 162, 162, 163, 153, 154, 
	154, 155, 156, 165, 165, 166, 166, 157, 
	157, 167, 167, 158, 158, 168, 168, 159, 
	159, 160, 160, 161, 161, 164, 164, 169
};

char *prodNames[] = {
	"start-1",
	"statement_list-1",
	"statement_list-2",
	"statement-1",
	"statement-2",
	"statement-3",
	"statement-4",
	"statement-5",
	"statement-6",
	"production_stmt-1",
	"token_stmt-1",
	"token_list-1",
	"token_list-2",
	"token_list_word-1",
	"translate_stmt-1",
	"nonterm_stmt-1",
	"nonterm_stmt-2",
	"type_stmt-1",
	"interface_stmt-1",
	"inline_list-1",
	"inline_list-2",
	"inline_block_item-1",
	"inline_block_item-2",
	"prod_el_list-1",
	"prod_el_list-2",
	"prod_el-1",
	"prod_el-2",
	"opt_commit-1",
	"opt_commit-2",
	"opt_prior-1",
	"opt_prior-2",
	"opt_reduction-1",
	"opt_reduction-2",
	"opt_undo-1",
	"opt_undo-2",
	"opt_final-1",
	"opt_final-2",
	"opt_translate-1",
	"opt_translate-2",
	"_start-1"
};

char *lelNames[] = {
	"D-0",
	"D-1",
	"D-2",
	"D-3",
	"D-4",
	"D-5",
	"D-6",
	"D-7",
	"D-8",
	"D-9",
	"D-10",
	"D-11",
	"D-12",
	"D-13",
	"D-14",
	"D-15",
	"D-16",
	"D-17",
	"D-18",
	"D-19",
	"D-20",
	"D-21",
	"D-22",
	"D-23",
	"D-24",
	"D-25",
	"D-26",
	"D-27",
	"D-28",
	"D-29",
	"D-30",
	"D-31",
	"D-32",
	"!",
	"\"",
	"#",
	"$",
	"%",
	"&",
	"'",
	"(",
	")",
	"*",
	"+",
	",",
	"-",
	".",
	"/",
	"0",
	"1",
	"2",
	"3",
	"4",
	"5",
	"6",
	"7",
	"8",
	"9",
	":",
	";",
	"<",
	"=",
	">",
	"?",
	"@",
	"A",
	"B",
	"C",
	"D",
	"E",
	"F",
	"G",
	"H",
	"I",
	"J",
	"K",
	"L",
	"M",
	"N",
	"O",
	"P",
	"Q",
	"R",
	"S",
	"T",
	"U",
	"V",
	"W",
	"X",
	"Y",
	"Z",
	"[",
	"\\",
	"]",
	"^",
	"_",
	"`",
	"a",
	"b",
	"c",
	"d",
	"e",
	"f",
	"g",
	"h",
	"i",
	"j",
	"k",
	"l",
	"m",
	"n",
	"o",
	"p",
	"q",
	"r",
	"s",
	"t",
	"u",
	"v",
	"w",
	"x",
	"y",
	"z",
	"{",
	"|",
	"}",
	"~",
	"D-127",
	"KW_Parser",
	"KW_Include",
	"TK_Word",
	"TK_String",
	"KW_Commit",
	"KW_Interface",
	"KW_Try",
	"KW_Undo",
	"KW_Final",
	"KW_Translate",
	"KW_Token",
	"KW_NonTerm",
	"KW_Uses",
	"KW_Type",
	"KW_Pri",
	"TK_Number",
	"TK_Inline",
	"TK_Reference",
	"TK_Literal",
	"_eof",
	"statement_list",
	"start",
	"statement",
	"production_stmt",
	"token_stmt",
	"translate_stmt",
	"nonterm_stmt",
	"type_stmt",
	"interface_stmt",
	"prod_el_list",
	"opt_commit",
	"opt_reduction",
	"opt_undo",
	"opt_final",
	"token_list",
	"token_list_word",
	"opt_translate",
	"inline_list",
	"inline_block_item",
	"prod_el",
	"opt_prior",
	"_start",
};

char prodCommit[] = {
	0, 0, 0, 1, 1, 1, 1, 1, 
	1, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0
};

#line 1 "klparse.kl"


void Parser::startSection()
{
	sawStart = false;
	sawInterface = false;
}

void Parser::endSection( )
{
	int endLine = 1; //id->sectionEndLoc.line;

	if ( sawInterface ) {
		if ( ! ::generateGraphviz )
			pd.generateHeader( endLine );
	}

	if ( sawStart ) {
		if ( ::generateGraphviz )
			pd.generateGraphviz();
		else 
			pd.generateCode( sawInterface, endLine );
	}
}

int Parser::token( int line, int tokid, char *data )
{
	Token token;
	token.data = data;
	token.loc.line = line;
	token.loc.col = 1;

	//cout << "SENDING TOKEN: " << lelNames[tokid];
	//if ( token.data != 0 )
	//	cout << " data: " << token.data;
	//cout << endl;

	return parseLangEl( tokid, token );
}
